/*-----------------------------------------------------------------------

File  : che_heu_simple.c

Author: Stephan Schulz

Contents
 
  See .h file

Changes

<1> Fri Dec 18 15:02:00 MET 1998
    New

-----------------------------------------------------------------------*/

#include "che_heu_simple.h"



/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/


/*-----------------------------------------------------------------------
//
// Function: HCBSingleCreate()
//
//   Create a HCB entry for the Single heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBSingleCreate(HCBARGUMENTS)
{
   HCB_p         hcb = HCBAlloc();
   
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w1") ,
	      1);

   return hcb;
}


/*-----------------------------------------------------------------------
//
// Function: HCBMix11Create()
//
//   Create a HCB entry for the Mix11 heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBMix11Create(HCBARGUMENTS)
{
   HCB_p         hcb = HCBAlloc();
   
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w1") ,
	      1);
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w2") ,
	      1);

   return hcb;
}

/*-----------------------------------------------------------------------
//
// Function: HCBMix21Create()
//
//   Create a HCB entry for the Mix21 heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBMix21Create(HCBARGUMENTS)
{
   HCB_p         hcb = HCBAlloc();
   
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w1") ,
	      2);
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w2") ,
	      1);

   return hcb;
}


/*-----------------------------------------------------------------------
//
// Function: HCBMix31Create()
//
//   Create a HCB entry for the Mix31 heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBMix31Create(HCBARGUMENTS)
{
   HCB_p         hcb = HCBAlloc();
   
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w1") ,
	      3);
   HCBAddWFCB(hcb, WFCBAdminFindWFCB(control->wfcbs, "w2") ,
	      1);

   return hcb;
}


/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/


