/*-----------------------------------------------------------------------

File  : cte_replace.h

Author: Stephan Schulz

Contents
 
  Functions for replacing and rewriting of terms.

  Copyright 1998, 1999 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Mon Jan 12 17:50:21 MET 1998
    New

-----------------------------------------------------------------------*/

#ifndef CTE_REPLACE

#define CTE_REPLACE

#include <clb_pqueue.h>
#include <cte_termpos.h>
#include <cio_output.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

#define RPL_TERM_WATCH 2048

typedef struct replace_cell
{
   Term_p  control;
   Term_p  term;
   Term_p  repl;
}ReplaceCell, *Replace_p;


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define ReplaceCellAlloc()     (ReplaceCell*)SizeMalloc(sizeof(ReplaceCell))
#define ReplaceCellFree(junk)  SizeFree(junk, sizeof(ReplaceCell))


void TBPropagateReplaceDataToSupers(Term_p term);
void TBTermReplace(TB_p bank, Term_p term, Term_p replace);
void TBTermReplaceRepro(TB_p bank, Term_p term, Term_p replace,
			PStack_p guide);
void TBNonCyclicTermReplace(TB_p bank, Term_p term, Term_p replace);

Term_p TBTermPosReplace(TB_p bank, Term_p repl, TermPos_p pos,
			DerefType deref);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





